# coding: utf-8

"""
    Wandelbots Nova API

    Interact with robots in an easy and intuitive way.  > **Note:** API version 2 is experimental and will experience functional changes. 

    The version of the OpenAPI document: 2.0.0 beta
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
import pprint
from pydantic import BaseModel, ConfigDict, Field, StrictStr, ValidationError, field_validator
from typing import Any, List, Optional
from wandelbots_api_client.v2.models.jogging_paused_collision import JoggingPausedCollision
from wandelbots_api_client.v2.models.jogging_paused_joint_limit import JoggingPausedJointLimit
from wandelbots_api_client.v2.models.jogging_paused_on_io import JoggingPausedOnIO
from wandelbots_api_client.v2.models.jogging_paused_user_request import JoggingPausedUserRequest
from wandelbots_api_client.v2.models.jogging_running import JoggingRunning
from pydantic import StrictStr, Field
from typing import Union, List, Set, Optional, Dict
from typing_extensions import Literal, Self

JOGGINGSTATE_ONE_OF_SCHEMAS = ["JoggingPausedCollision", "JoggingPausedJointLimit", "JoggingPausedOnIO", "JoggingPausedUserRequest", "JoggingRunning"]

class JoggingState(BaseModel):
    """
    JoggingState
    """
    # data type: JoggingRunning
    oneof_schema_1_validator: Optional[JoggingRunning] = None
    # data type: JoggingPausedUserRequest
    oneof_schema_2_validator: Optional[JoggingPausedUserRequest] = None
    # data type: JoggingPausedJointLimit
    oneof_schema_3_validator: Optional[JoggingPausedJointLimit] = None
    # data type: JoggingPausedCollision
    oneof_schema_4_validator: Optional[JoggingPausedCollision] = None
    # data type: JoggingPausedOnIO
    oneof_schema_5_validator: Optional[JoggingPausedOnIO] = None
    actual_instance: Optional[Union[JoggingPausedCollision, JoggingPausedJointLimit, JoggingPausedOnIO, JoggingPausedUserRequest, JoggingRunning]] = None
    one_of_schemas: Set[str] = { "JoggingPausedCollision", "JoggingPausedJointLimit", "JoggingPausedOnIO", "JoggingPausedUserRequest", "JoggingRunning" }

    model_config = ConfigDict(
        validate_assignment=True,
        protected_namespaces=(),
    )


    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @field_validator('actual_instance')
    def actual_instance_must_validate_oneof(cls, v):
        instance = JoggingState.model_construct()
        error_messages = []
        match = 0
        # validate data type: JoggingRunning
        if not isinstance(v, JoggingRunning):
            error_messages.append(f"Error! Input type `{type(v)}` is not `JoggingRunning`")
        else:
            match += 1
        # validate data type: JoggingPausedUserRequest
        if not isinstance(v, JoggingPausedUserRequest):
            error_messages.append(f"Error! Input type `{type(v)}` is not `JoggingPausedUserRequest`")
        else:
            match += 1
        # validate data type: JoggingPausedJointLimit
        if not isinstance(v, JoggingPausedJointLimit):
            error_messages.append(f"Error! Input type `{type(v)}` is not `JoggingPausedJointLimit`")
        else:
            match += 1
        # validate data type: JoggingPausedCollision
        if not isinstance(v, JoggingPausedCollision):
            error_messages.append(f"Error! Input type `{type(v)}` is not `JoggingPausedCollision`")
        else:
            match += 1
        # validate data type: JoggingPausedOnIO
        if not isinstance(v, JoggingPausedOnIO):
            error_messages.append(f"Error! Input type `{type(v)}` is not `JoggingPausedOnIO`")
        else:
            match += 1
        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when setting `actual_instance` in JoggingState with oneOf schemas: JoggingPausedCollision, JoggingPausedJointLimit, JoggingPausedOnIO, JoggingPausedUserRequest, JoggingRunning. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when setting `actual_instance` in JoggingState with oneOf schemas: JoggingPausedCollision, JoggingPausedJointLimit, JoggingPausedOnIO, JoggingPausedUserRequest, JoggingRunning. Details: " + ", ".join(error_messages))
        else:
            return v

    @classmethod
    def from_dict(cls, obj: Union[str, Dict[str, Any]]) -> Self:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Returns the object represented by the json string"""
        instance = cls.model_construct()
        error_messages = []
        match = 0

        # deserialize data into JoggingRunning
        try:
            instance.actual_instance = JoggingRunning.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into JoggingPausedUserRequest
        try:
            instance.actual_instance = JoggingPausedUserRequest.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into JoggingPausedJointLimit
        try:
            instance.actual_instance = JoggingPausedJointLimit.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into JoggingPausedCollision
        try:
            instance.actual_instance = JoggingPausedCollision.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into JoggingPausedOnIO
        try:
            instance.actual_instance = JoggingPausedOnIO.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when deserializing the JSON string into JoggingState with oneOf schemas: JoggingPausedCollision, JoggingPausedJointLimit, JoggingPausedOnIO, JoggingPausedUserRequest, JoggingRunning. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when deserializing the JSON string into JoggingState with oneOf schemas: JoggingPausedCollision, JoggingPausedJointLimit, JoggingPausedOnIO, JoggingPausedUserRequest, JoggingRunning. Details: " + ", ".join(error_messages))
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        if hasattr(self.actual_instance, "to_json") and callable(self.actual_instance.to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> Optional[Union[Dict[str, Any], JoggingPausedCollision, JoggingPausedJointLimit, JoggingPausedOnIO, JoggingPausedUserRequest, JoggingRunning]]:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        if hasattr(self.actual_instance, "to_dict") and callable(self.actual_instance.to_dict):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.model_dump())


