# coding: utf-8

"""
    Wandelbots Nova API

    Interact with robots in an easy and intuitive way.  > **Note:** API version 2 is experimental and will experience functional changes. 

    The version of the OpenAPI document: 2.0.0 beta
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
from enum import Enum
from typing_extensions import Self


class OperationMode(str, Enum):
    """
    Current operation mode of the configured robot controller. Operation modes in which the attached motion groups can be moved are: - OPERATION_MODE_MANUAL (if enabling switch is pressed) - OPERATION_MODE_MANUAL_T1 (if enabling switch is pressed) - OPERATION_MODE_MANUAL_T2 (if enabling switch is pressed) - OPERATION_MODE_AUTO (without needing to press enabling switch) All other modes are considered as non-operational. 
    """

    """
    allowed enum values
    """
    OPERATION_MODE_UNKNOWN = 'OPERATION_MODE_UNKNOWN'
    OPERATION_MODE_NO_CONTROLLER = 'OPERATION_MODE_NO_CONTROLLER'
    OPERATION_MODE_DISCONNECTED = 'OPERATION_MODE_DISCONNECTED'
    OPERATION_MODE_POWER_ON = 'OPERATION_MODE_POWER_ON'
    OPERATION_MODE_PENDING = 'OPERATION_MODE_PENDING'
    OPERATION_MODE_MANUAL = 'OPERATION_MODE_MANUAL'
    OPERATION_MODE_MANUAL_T1 = 'OPERATION_MODE_MANUAL_T1'
    OPERATION_MODE_MANUAL_T2 = 'OPERATION_MODE_MANUAL_T2'
    OPERATION_MODE_AUTO = 'OPERATION_MODE_AUTO'
    OPERATION_MODE_RECOVERY = 'OPERATION_MODE_RECOVERY'

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of OperationMode from a JSON string"""
        return cls(json.loads(json_str))


